//+------------------------------------------------------------------+
//|                                                     Strategy.mq4 |
//|                                Copyright  2010, Richard Saldana |
//|                                                  Richard Saldana |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Richard Saldana"
#property link      "Richard Saldana"

#property indicator_chart_window

#include <WinUser32.mqh>

extern bool    Email_Alert = False;
extern bool    PopUp_Alert = False;
extern bool    Sound_Alert = False;
extern bool    Draw_Arrows = True;
extern int     Strategy_Type = 3;
extern int 		MaxBars  = 1000;

double var_BBands_Dwn;
double var_BBands_Up;
double var_Heiken_Ashi_Buy;
double var_Heiken_Ashi_Sell;

double var_PJ_Cur;
double var_PJ_Prev;
double var_PJ_PPrev;

double var_MACD_Cur_Buy;
double var_MACD_Prev_Buy;
double var_MACD_PPrev_Buy;

double var_MACD_Cur_Sell;
double var_MACD_Prev_Sell;
double var_MACD_PPrev_Sell;

double var_RSI_8;
double var_Stoch_14_3_3;

bool signal_Buy;
bool signal_Sell;
bool down_Touch_BB;
bool up_Touch_BB;

static datetime dt = 0;
int cntr;

int init()
  {
      var_BBands_Dwn = 0;
      var_BBands_Up = 0;
      var_Heiken_Ashi_Sell = 0;
      var_Heiken_Ashi_Buy = 0;
      cntr = 0;
      signal_Buy = False;
      signal_Sell = False;
      down_Touch_BB = False;
      up_Touch_BB = False;
      
      int varBars = MathMin(Bars,MaxBars);
      
      for(int i = varBars; i >= 1; i--)
         {
            if (Strategy_Type == 1)
               {
                  var_MACD_Cur_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i);
                  var_MACD_Prev_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i+1);
                  var_MACD_PPrev_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i+6);
                  
                  var_MACD_Cur_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i);
                  var_MACD_Prev_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i+1);
                  var_MACD_PPrev_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i+6);
                  
                  var_Heiken_Ashi_Buy = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,0,i);
                  var_Heiken_Ashi_Sell = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,2,i);
                  
                  if (iCustom(NULL,0,"Pj-over RSI",21,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,1,i)==1) var_PJ_Cur = 5;
                  if (iCustom(NULL,0,"Pj-over RSI",21,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,3,i)==1) var_PJ_Cur = 5;
                  if (iCustom(NULL,0,"Pj-over RSI",21,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,0,i)==1) var_PJ_Cur = 3;
                  if (iCustom(NULL,0,"Pj-over RSI",21,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,2,i)==1) var_PJ_Cur = 3;
                  
                  if (var_MACD_Cur_Buy > var_MACD_Prev_Buy && var_MACD_Prev_Buy < var_MACD_PPrev_Buy && var_MACD_Cur_Buy < 1)
                     {
                        if (var_Heiken_Ashi_Buy<Low[i])
                           {
                              if(!signal_Buy && var_PJ_Cur == 3 && var_PJ_Prev == 5 && var_PJ_PPrev == 3)
                                 {
                                    if (Draw_Arrows) Draw_The_Arrow(i,3);
                                    signal_Buy = True;
                                    signal_Sell = False;
                                 }
                              if(!signal_Buy && var_PJ_Cur == 3)
                                 {
                                    if (Draw_Arrows) Draw_The_Arrow(i,3);
                                    signal_Buy = True;
                                    signal_Sell = False;
                                 }
                           }
                     }
                     
                  if (var_MACD_Cur_Sell < var_MACD_Prev_Sell && var_MACD_Prev_Sell > var_MACD_PPrev_Sell && var_MACD_Cur_Sell < 1)
                     {
                        if (var_Heiken_Ashi_Sell>High[i]) 
                           {
                              if(!signal_Sell && var_PJ_Cur == 5 && var_PJ_Prev == 3 && var_PJ_PPrev == 5)
                                 {
                                    if (Draw_Arrows) Draw_The_Arrow(i,5);
                                    signal_Buy = False;
                                    signal_Sell = True;
                                 }
                              if(!signal_Sell && var_PJ_Cur == 5)
                                 {
                                    if (Draw_Arrows) Draw_The_Arrow(i,5);
                                    signal_Buy = False;
                                    signal_Sell = True;
                                 }
                           }
                     }
               }
               
            if (Strategy_Type == 2)
               {
                  var_BBands_Dwn = iBands(NULL,0,50,3,0,PRICE_CLOSE,MODE_LOWER,i);
                  var_BBands_Up = iBands(NULL,0,50,3,0,PRICE_CLOSE,MODE_UPPER,i);
                  var_Heiken_Ashi_Buy = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,0,i);
                  var_Heiken_Ashi_Sell = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,2,i);
                  
                  var_RSI_8 = iRSI(NULL,0,8,PRICE_CLOSE,i);
                  var_Stoch_14_3_3 = iStochastic(NULL,0,14,3,3,MODE_EMA,1,MODE_MAIN,i);
                  
                  //var_MACD_Cur_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i);
                  //var_MACD_Prev_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i+1);
                  //var_MACD_PPrev_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i+6);
                  
                  //var_MACD_Cur_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i);
                  //var_MACD_Prev_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i+1);
                  //var_MACD_PPrev_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i+6);
                  
                  if (Low[i] <= var_BBands_Dwn && !down_Touch_BB && var_RSI_8 <= 30 && var_Stoch_14_3_3 <= 20) down_Touch_BB = True;

                  if (down_Touch_BB && var_Heiken_Ashi_Buy<Low[i]) 
                     {
                        //if (var_MACD_Cur_Buy > var_MACD_Prev_Buy && var_MACD_Prev_Buy < var_MACD_PPrev_Buy && var_MACD_Cur_Buy < 1)
                        //if(var_RSI_8 <= 30 && var_Stoch_14_3_3 <= 20)
                           {
                              if (Draw_Arrows) Draw_The_Arrow(i,3);
                              down_Touch_BB = False;
                           }
                     }
           
                  if (High[i] >= var_BBands_Up && !up_Touch_BB && var_RSI_8 >= 70 && var_Stoch_14_3_3 >= 80) up_Touch_BB = True;

                  if (up_Touch_BB && var_Heiken_Ashi_Sell>High[i]) 
                     {
                        //if (var_MACD_Cur_Sell < var_MACD_Prev_Sell && var_MACD_Prev_Sell > var_MACD_PPrev_Sell && var_MACD_Cur_Sell < 1)
                        //if(var_RSI_8 >= 70 && var_Stoch_14_3_3 >= 80)
                           {
                              if (Draw_Arrows) Draw_The_Arrow(i,5);
                              up_Touch_BB = False;
                           }
                     }
               }
            
            if (Strategy_Type == 3)
               {
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,1,i)==1) var_PJ_Cur = 5;
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,3,i)==1) var_PJ_Cur = 5;
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,0,i)==1) var_PJ_Cur = 3;
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,2,i)==1) var_PJ_Cur = 3;
                  
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,1,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,1,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,1,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,1,i+1)==1) var_PJ_Prev = 5;
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,3,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,3,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,3,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,3,i+1)==1) var_PJ_Prev = 5;
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,0,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,0,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,0,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,0,i+1)==1) var_PJ_Prev = 3;
                  if (iCustom(NULL,0,"Pj-over RSI",14,50,50,2,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,2,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,2,i+1)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,2,i+1)==1) var_PJ_Prev = 3;
                  
                  //if (iCustom(NULL,0,"Pj-over RSI",21,50,50,1,i+2)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,1,i+2)==1) var_PJ_PPrev = 5;
                  //if (iCustom(NULL,0,"Pj-over RSI",21,50,50,3,i+2)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,3,i+2)==1) var_PJ_PPrev = 5;
                  //if (iCustom(NULL,0,"Pj-over RSI",21,50,50,0,i+2)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,0,i+2)==1) var_PJ_PPrev = 3;
                  //if (iCustom(NULL,0,"Pj-over RSI",21,50,50,2,i+2)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,2,i+2)==1) var_PJ_PPrev = 3;
                  
                  //if(!signal_Sell && var_PJ_Cur == 5 && var_PJ_Prev == 5)
                  if(!signal_Sell && var_PJ_Cur == 5)
                     {
                        if (Draw_Arrows) Draw_The_Arrow(i,5);
                        signal_Buy = False;
                        signal_Sell = True;
                     }
                  //if(!signal_Sell && var_PJ_Cur == 5)
                  //   {
                  //      if (Draw_Arrows) Draw_The_Arrow(i,5);
                  //      signal_Buy = False;
                  //      signal_Sell = True;
                  //   }
                     
                  //if(!signal_Buy && var_PJ_Cur == 3 && var_PJ_Prev == 3)
                  if(!signal_Buy && var_PJ_Cur == 3)
                     {
                        if (Draw_Arrows) Draw_The_Arrow(i,3);
                        signal_Buy = True;
                        signal_Sell = False;
                     }
                  //if(!signal_Buy && var_PJ_Cur == 3)
                  //   {
                  //      if (Draw_Arrows) Draw_The_Arrow(i,3);
                  //      signal_Buy = True;
                  //      signal_Sell = False;
                  //   }
               }
         }

      return(0);
  }

int deinit()
  {
      int varTotalObjects = ObjectsTotal();
      string varSubStr;
      for(int i = varTotalObjects - 1; i >= 0; i--)
         {
            varSubStr=ObjectName(i);
            if(StringFind(varSubStr, "3SS_")>=0 )
               {
                  ObjectDelete(varSubStr);
               }
         }
      return(0);
  }

int start()
  {
      int    counted_bars=IndicatorCounted();
      
      int i = 1;
      
      if (Strategy_Type == 1)
         {
            var_MACD_Cur_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i);
            var_MACD_Prev_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i+1);
            var_MACD_PPrev_Buy = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i+6);
                  
            var_MACD_Cur_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,1,i);
            var_MACD_Prev_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i+1);
            var_MACD_PPrev_Sell = iCustom(NULL,0,"OsMA_ColorHist_2_tf",5,12,26,9,12,26,9,0,0,1000,0,i+6);
                  
            var_Heiken_Ashi_Buy = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,0,i);
            var_Heiken_Ashi_Sell = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,2,i);
                  
            if (iCustom(NULL,0,"Pj-over RSI",21,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,1,i)==1) var_PJ_Cur = 5;
            if (iCustom(NULL,0,"Pj-over RSI",21,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,3,i)==1) var_PJ_Cur = 5;
            if (iCustom(NULL,0,"Pj-over RSI",21,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,0,i)==1) var_PJ_Cur = 3;
            if (iCustom(NULL,0,"Pj-over RSI",21,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",50,50,50,2,i)==1) var_PJ_Cur = 3;
                  
            if (var_MACD_Cur_Buy > var_MACD_Prev_Buy && var_MACD_Prev_Buy < var_MACD_PPrev_Buy && var_MACD_Cur_Buy < 1)
               {
                  if (var_Heiken_Ashi_Buy<Low[i])
                     {
                        if(!signal_Buy && var_PJ_Cur == 3 && var_PJ_Prev == 5 && var_PJ_PPrev == 3)
                           {
                              if (Draw_Arrows) Draw_The_Arrow(i,3);
                              if(NewBar()) ShowMessages("#1 Strategy Signal BUY");
                              signal_Buy = True;
                              signal_Sell = False;
                           }
                        if(!signal_Buy && var_PJ_Cur == 3)
                           {
                              if (Draw_Arrows) Draw_The_Arrow(i,3);
                              if(NewBar()) ShowMessages("#1 Strategy Signal BUY");
                              signal_Buy = True;
                              signal_Sell = False;
                           }
                     }
               }
                     
            if (var_MACD_Cur_Sell < var_MACD_Prev_Sell && var_MACD_Prev_Sell > var_MACD_PPrev_Sell && var_MACD_Cur_Sell < 1)
               {
                  if (var_Heiken_Ashi_Sell>High[i]) 
                     {
                        if(!signal_Sell && var_PJ_Cur == 5 && var_PJ_Prev == 3 && var_PJ_PPrev == 5)
                           {
                              if (Draw_Arrows) Draw_The_Arrow(i,5);
                              if(NewBar()) ShowMessages("#1 Strategy Signal SELL");
                              signal_Buy = False;
                              signal_Sell = True;
                           }
                        if(!signal_Sell && var_PJ_Cur == 5)
                           {
                              if (Draw_Arrows) Draw_The_Arrow(i,5);
                              if(NewBar()) ShowMessages("#1 Strategy Signal SELL");
                              signal_Buy = False;
                              signal_Sell = True;
                           }
                     }
               }
         }
      
      
      if (Strategy_Type == 2)
         {
            var_BBands_Dwn = iBands(NULL,0,50,3,0,PRICE_CLOSE,MODE_LOWER,i);
            var_BBands_Up = iBands(NULL,0,50,3,0,PRICE_CLOSE,MODE_UPPER,i);
            var_Heiken_Ashi_Buy = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,0,i);
            var_Heiken_Ashi_Sell = iCustom(NULL,0,"Heiken Ashi",NULL,NULL,NULL,NULL,2,i);
                  
            var_RSI_8 = iRSI(NULL,0,8,PRICE_CLOSE,i);
            var_Stoch_14_3_3 = iStochastic(NULL,0,14,3,3,MODE_EMA,1,MODE_MAIN,i);
            
            if (Low[i] <= var_BBands_Dwn && !down_Touch_BB && var_RSI_8 <= 30 && var_Stoch_14_3_3 <= 20) down_Touch_BB = True;

            if (down_Touch_BB && var_Heiken_Ashi_Buy<Low[i])
               {
                  if (Draw_Arrows) Draw_The_Arrow(i,3);
                  if(NewBar()) ShowMessages("#2 Strategy Signal BUY");
                  down_Touch_BB = False;
               }
        
            if (High[i] >= var_BBands_Up && !up_Touch_BB && var_RSI_8 >= 70 && var_Stoch_14_3_3 >= 80) up_Touch_BB = True;

            if (up_Touch_BB && var_Heiken_Ashi_Sell>High[i]) 
               {
                  if (Draw_Arrows) Draw_The_Arrow(i,5);
                  if(NewBar()) ShowMessages("#2 Strategy Signal SELL");
                  up_Touch_BB = False;
               }
         }
      
      
      if (Strategy_Type == 3)
         {
            if (iCustom(NULL,0,"Pj-over RSI",14,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,1,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,1,i)==1) var_PJ_Cur = 5;
            if (iCustom(NULL,0,"Pj-over RSI",14,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,3,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,3,i)==1) var_PJ_Cur = 5;
            if (iCustom(NULL,0,"Pj-over RSI",14,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,0,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,0,i)==1) var_PJ_Cur = 3;
            if (iCustom(NULL,0,"Pj-over RSI",14,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",21,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",28,50,50,2,i)==1 && iCustom(NULL,0,"Pj-over RSI",35,50,50,2,i)==1) var_PJ_Cur = 3;
                  
            if(!signal_Sell && var_PJ_Cur == 5)
               {
                  if (Draw_Arrows) Draw_The_Arrow(i,5);
                  if(NewBar()) ShowMessages("#3 Strategy Signal SELL");
                  signal_Buy = False;
                  signal_Sell = True;
               }
            if(!signal_Buy && var_PJ_Cur == 3)
               {
                  if (Draw_Arrows) Draw_The_Arrow(i,3);
                  if(NewBar()) ShowMessages("#3 Strategy Signal BUY");
                  signal_Buy = True;
                  signal_Sell = False;
               }
         }
      
      return(0);
  }

void Draw_The_Arrow(int i,int dirrection)
   {
      cntr++;
      string var_Arr_Name = "3SS_" + cntr;
     
      if (dirrection == 5)
         {
            ObjectCreate(var_Arr_Name,OBJ_ARROW,0,Time[i],High[i]+25*Point);
            ObjectSet(var_Arr_Name,OBJPROP_ARROWCODE,234);
            ObjectSet(var_Arr_Name,OBJPROP_COLOR,Red);
         }
      if (dirrection == 3)
         {
            ObjectCreate(var_Arr_Name,OBJ_ARROW,0,Time[i],Low[i]-15*Point);
            ObjectSet(var_Arr_Name,OBJPROP_ARROWCODE,233);
            ObjectSet(var_Arr_Name,OBJPROP_COLOR,Green);
         }
      return(0);
   }

void ShowMessages(string buyOrSell)
   {
      string TimeFrameStr;
         switch(Period())
         {
            case PERIOD_M1:  TimeFrameStr="(M1)";      break;
            case PERIOD_M5:  TimeFrameStr="(M5)";      break;
            case PERIOD_M15: TimeFrameStr="(M15)";     break;
            case PERIOD_M30: TimeFrameStr="(M30)";     break;
            case PERIOD_H1:  TimeFrameStr="(H1)";      break;
            case PERIOD_H4:  TimeFrameStr="(H4)";      break;
            case PERIOD_D1:  TimeFrameStr="(Dayly)";   break;
            case PERIOD_W1:  TimeFrameStr="(Weekly)";  break;
            case PERIOD_MN1: TimeFrameStr="(Monthly)"; break;
            default :        TimeFrameStr="";
         }
      
      int var_cur_Hour = TimeHour(LocalTime());
      int var_cur_Min = TimeMinute(LocalTime());
      
      string varMesStr = "3 Strategy Signal Indicator - " + buyOrSell + "\n";
      varMesStr = varMesStr + " Current Date is: " + Month( ) + "-" + Day( ) + "-" + Year( ) + "\n";
      varMesStr = varMesStr + " Current System Time is: " + var_cur_Hour + ":" + var_cur_Min + "\n";
      varMesStr = varMesStr + " Current Chart Symbol is: " + Symbol() + "\n";
      varMesStr = varMesStr + " Current Time Frame is: " + TimeFrameStr + "\n";
      varMesStr = varMesStr + " Current Open Bar Price is: " + Open[0] + "\n";
      if(PopUp_Alert) 
         {
            Alert(varMesStr);
         }
      if(Email_Alert)
         {
            SendMail(buyOrSell,varMesStr);
         }
      if(Sound_Alert)
         {
            PlaySound("alert.wav");
         }
         
      return(0);
   }

bool NewBar()
{
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}